function lib_Inspc_genBusSfunc()
%
%% Generates Sfunction wrapper and tlc file from information in the header file. 
% NOTE: This file needs a licensed script file see include statement in this script
% Please contact hartmut.schorrig@vishia.de to get more information.
% The generated wrapper and tlc should be stored additionally, so you can% compile 
% mex files nevertheless with unchanged S-function wrapper (unchanged interface of the Sfunction)
%
rootPath = evalin('base', 'rootPath');
display(rootPath);
clc
clear mex
currdir_ = pwd;
cd(rootPath);
socketlib = { fullfile(matlabroot,'sys\lcc64\lcc64\lib64\ws2_32.lib')} 
socketlibcopy = strjoin(['copy ', socketlib, ' lib\mex\*']);
system(socketlibcopy); %%copy the socket lib to a local position.
disp('Generate S-Fuctions for lib_Inspc ...');
system('java.exe -cp ../../ZBNF/zbnfjax/zbnf.jar org.vishia.jztxtcmd.JZtxtcmd lib/+mkSfn/lib_Inspc_genSfH.m');
%genBus.lib_Inspc_genBus();  %just generated script
genSfn.lib_Inspc_mex();    %just generated script.
%genSfn.lib_Inspc_mexdbg();    %just generated script.
disp('successfull')
cd(currdir_);
end
%{
==JZtxtcmd==
currdir = <:><&scriptdir>/../..<.>;                          ##the scriptdir is the simulink root dir.
include ../../../SmlkSfunc_jzTc/simulinkSfuncBusGen.jzTc;  ##out of the box, see below

##Important note: To complile the Inspector-Sfunctions newly you need three things outside of this simulink box.
##They should be placed in file system parallel to this this current dir 'smlk/SMLK_PRJ/Simulink'.
##1. The JZtxtcmd script engine. It is contained in 'ZBNF/zbnfjax/zbnfjax.zbnf'.
##   It is only used in the Java invocation as class path.
##2. Sources of Inspector. They are part of the 'emC' source pool, hosted on Github /jzHartmut.
##   That sources are used here in a directory parallel to this current dir 'smlk/*/Simulink' in 'emc/*'
##3. The scripts to generate S-Funtion wrapper. This script is included above with relative path.
##   This scripts are not open source. you can get it with a low fee (one week coaching) from vishia.org.


Fileset srcHeader =  ##from this header Sfunctions are generated.
( ../../emc/source:Inspc/TimeSignals_Inspc.h  ##Stimulation for Simulink
##not ready yet: , ../../emc/source:Inspc/InputValues_Inspc.h
, ../../emc/source:Inspc/Service_Inspc.h   ##The core FB for Inspector service
, ../../emc/source:Inspc/DataNode_Inspc.h
##not ready yet: , ../../emc/source:Inspc/Wait_Inspc.h
, ../../emc/source:Inspc/GetValue_Inspc.h   ##access to internal data, output to simulink
);


Fileset includepath = 
( ../../emc
, ../../emc
, ../../emc/source
, ../../emc/incApplSpecific/stdef_SmlkSfuncExcH
, ../../emc/incComplSpecific/cc_SmlkSfunc_64bit
);


## All sources for compilation to the named header file, except the generated Sfunc-wrapper.
Fileset src_TimeSignals_Inspc = 
( ../../emc/source/Inspc/TimeSignals_Inspc.c
, ../../emc/source/Inspc/DataNode_Inspc.c
, ../../emc/source/emC/MemC_emC.c
, ../../emc/source/emC/SimpleC_emC.c
, ../../emc/source/emC/String_emC.c
, ../../emc/source/emC/StringBase_emC.c
, ../../emc/source/emC/StringBuilder_emC.c
, ../../emc/source/emC/Object_emC.c
, ../../emc/source/emC/Reflection_emC.c
, ../../emc/source/emC/ReflectionBaseTypes_emC.c
, ../../emc/source/emC/Formatter_emC.c
, ../../emc/source/emC/timeconversions_emC.c
, ../../emc/source/emC/handle_ptr64_emC.c
, ../../emc/source/emC/Memfree_ThreadAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/Exception_emC.c
, ../../emc/sourceApplSpecific/applConv/ExceptionPrintStacktrace_emC.c
, ../../emc/sourceApplSpecific/applConv/ApplSimpleStop_emC.c                 ##TODO force error message in SImulink
, ../../emc/sourceApplSpecific/applConv/ThreadContextMultiThreading_emC.c
, ../../emc/sourceApplSpecific/applConv/ObjectJc_allocStartup_emC.c
, ../../emc/sourceApplSpecific/applConv/UmlContainer_Dummy.c        
, ../../emc/sourceApplSpecific/applConv/RemoteCpu_Dummy.c
, ../../emc/source/Jc/ObjectJc.c
, ../../emc/source/Jc/StringJc.c
, ../../emc/source/Jc/StringBufferJc.c
, ../../emc/source/J1c/StringFunctionsJc.c
, ../../emc/source/J1c/StringFunctions_CJc.c
, ../../emc/source/Jc/ReflectionJc.c
, ../../emc/source/Jc/ReflectionBaseTypesJc.c
, ../../emc/source/Jc/ReflMemAccessJc.c
, ../../emc/source/Jc/FileIoJc.c                          
, ../../emc/source/Jc/LocaleJc.c  
, ../../emc/source/refl/Reflection_OSAL.c
, ../../emc/source/OSAL/os_common.c
, ../../emc/sourceSpecials/os_Windows_64/os_atomic.c  
, ../../emc/sourceSpecials/osal_Windows/os_mem.c
, ../../emc/sourceSpecials/osal_Windows_Msc15/os_file.c
, ../../emc/sourceSpecials/osal_Windows/os_time.c
, ../../emc/sourceSpecials/osal_Windows/os_mutex.c
, ../../emc/sourceSpecials/osal_Windows/os_thread.c
, ../../emc/sourceSpecials/osal_Windows/os_sharedmem.c
);



Fileset src_InputValues_Inspc = 
( ../../emc/source/Inspc/InputValues_Inspc.c
, ../../emc/source/Inspc/FBaccessNode_RegisterRefl_Inspc.c
, ../../emc/source/Fwc/fw_MemC.c
, ../../emc/source/Fwc/fw_SimpleC.c
, ../../emc/source/Fwc/fw_String.c
, ../../emc/source/Fwc/fw_Exception.c
, ../../emc/source/Fwc/fw_ExceptionPrintStacktrace.c
, ../../emc/source/Fwc/fw_Object.c
, ../../emc/source/Fwc/fw_ReflectionBaseTypes.c
, ../../emc/source/Fwc/fw_Formatter.c
, ../../emc/source/Fwc/fw_timeconversions.c
, ../../emc/source/Fwc/fw_ThreadContext.c
, ../../emc/source/Fwc/fw_handle_ptr64.c
, ../../emc/source/Jc/ObjectJc.c
, ../../emc/source/Jc/StringJc.c
, ../../emc/source/Jc/StringBufferJc.c
, ../../emc/source/J1c/StringFunctionsJc.c
, ../../emc/source/J1c/StringFunctions_CJc.c
, ../../emc/source/Jc/ReflectionJc.c
, ../../emc/source/Jc/ReflectionBaseTypesJc.c
, ../../emc/source/Jc/ReflMemAccessJc.c
, ../../emc/source/Jc/FileIoJc.c                          
, ../../emc/source/Jc/LocaleJc.c  
, ../../emc/sourceSpecials/FwConv_c/fw_PlatformConvSimpleStop.c 
, ../../emc/sourceSpecials/FwConv_c/allocOnlyAtStartup.c
, ../../emc/sourceSpecials/FwConv_c/free_ThreadHeapAndBlockHeap.c
, ../../emc/sourceSpecials/FwConv_c/UmlContainer_Dummy.c        
, ../../emc/sourceSpecials/FwConv_c/RemoteCpu_Dummy.c
, ../../emc/source/refl/Reflection_AllJc.c
, ../../emc/source/refl/Reflection_OSAL.c
, ../../emc/source/OSAL/os_common.c
, ../../emc/sourceSpecials/os_Windows_64/os_atomic.c  
, ../../emc/sourceSpecials/os_Windows_64/os_mem.c
, ../../emc/sourceSpecials/os_Windows_64/os_error.c
, ../../emc/sourceSpecials/os_Windows_64/os_file.c
, ../../emc/sourceSpecials/os_Windows_64/os_time.c
, ../../emc/sourceSpecials/os_Windows_64/os_mutex.c
, ../../emc/sourceSpecials/os_Windows_64/os_thread.c
, ../../emc/sourceSpecials/os_Windows_64/os_sharedmem.c
);


## All sources for compilation to the named header file, except the generated Sfunc-wrapper.
Fileset src_Wait_Inspc = 
( ../../emc/source/Inspc/Wait_Inspc.c
, ../../emc/source/Inspc/FBaccessNode_RegisterRefl_Inspc.c
, ../../emc/source/Fwc/fw_ReflectionBaseTypes.c
, ../../emc/source/Fwc/fw_Object.c
, ../../emc/source/Fwc/fw_MemC.c
, ../../emc/source/Fwc/fw_SimpleC.c
, ../../emc/source/Fwc/fw_String.c
, ../../emc/source/Fwc/fw_Formatter.c
, ../../emc/source/Fwc/fw_timeconversions.c
, ../../emc/source/Fwc/fw_ThreadContext.c
, ../../emc/source/Jc/ObjectJc.c
, ../../emc/source/Jc/StringJc.c
, ../../emc/source/Jc/StringBufferJc.c
, ../../emc/source/Fwc/fw_handle_ptr64.c
, ../../emc/source/Fwc/fw_Exception.c
, ../../emc/source/Fwc/fw_ExceptionPrintStacktrace.c
, ../../emc/sourceSpecials/FwConv_c/allocOnlyAtStartup.c
, ../../emc/sourceSpecials/FwConv_c/fw_PlatformConvSimpleStop.c 
, ../../emc/sourceSpecials/FwConv_c/free_ThreadHeapAndBlockHeap.c
, ../../emc/sourceSpecials/os_Windows_64/os_atomic.c  
, ../../emc/sourceSpecials/os_Windows_64/os_mem.c
, ../../emc/sourceSpecials/os_Windows_64/os_file.c
, ../../emc/sourceSpecials/os_Windows_64/os_time.c
, ../../emc/sourceSpecials/os_Windows_64/os_error.c
, ../../emc/sourceSpecials/os_Windows_64/os_mutex.c
, ../../emc/sourceSpecials/os_Windows_64/os_thread.c
, ../../emc/sourceSpecials/os_Windows_64/os_sharedmem.c
);



Fileset src_DataNode_Inspc = 
( ../../emc/source/Inspc/DataNode_Inspc.c
, ../../emc/source/emC/MemC_emC.c
, ../../emc/source/emC/SimpleC_emC.c
, ../../emc/source/emC/String_emC.c
, ../../emc/source/emC/StringBase_emC.c
, ../../emc/source/emC/StringBuilder_emC.c
, ../../emc/source/emC/Object_emC.c
, ../../emc/source/emC/Reflection_emC.c
, ../../emc/source/emC/ReflectionBaseTypes_emC.c
, ../../emc/source/emC/Formatter_emC.c
, ../../emc/source/emC/timeconversions_emC.c
, ../../emc/source/emC/handle_ptr64_emC.c
, ../../emc/source/emC/Memfree_ThreadAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/Exception_emC.c
, ../../emc/sourceApplSpecific/applConv/ExceptionPrintStacktrace_emC.c
, ../../emc/sourceApplSpecific/applConv/ApplSimpleStop_emC.c                 ##TODO force error message in SImulink
, ../../emc/sourceApplSpecific/applConv/ThreadContextMultiThreading_emC.c
##, ../../emc/sourceApplSpecific/applConv/PlatformConvSimpleStop.c 
, ../../emc/sourceApplSpecific/applConv/ObjectJc_allocStartup_emC.c
##, ../../emc/sourceSpecials/FwConv_c/free_ThreadHeapAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/UmlContainer_Dummy.c        
, ../../emc/sourceApplSpecific/applConv/RemoteCpu_Dummy.c
, ../../emc/source/Jc/ObjectJc.c
, ../../emc/source/Jc/StringJc.c
, ../../emc/source/Jc/StringBufferJc.c
, ../../emc/source/J1c/StringFunctionsJc.c
, ../../emc/source/J1c/StringFunctions_CJc.c
, ../../emc/source/Jc/ReflectionJc.c
, ../../emc/source/Jc/ReflectionBaseTypesJc.c
, ../../emc/source/Jc/ReflMemAccessJc.c
, ../../emc/source/Jc/FileIoJc.c                          
, ../../emc/source/Jc/LocaleJc.c  
, ../../emc/source/refl/Reflection_OSAL.c
, ../../emc/source/OSAL/os_common.c
, ../../emc/sourceSpecials/os_Windows_64/os_atomic.c  
, ../../emc/sourceSpecials/osal_Windows/os_mem.c
, ../../emc/sourceSpecials/osal_Windows_Msc15/os_file.c
, ../../emc/sourceSpecials/osal_Windows/os_time.c
, ../../emc/sourceSpecials/osal_Windows/os_mutex.c
, ../../emc/sourceSpecials/osal_Windows/os_thread.c
, ../../emc/sourceSpecials/osal_Windows/os_sharedmem.c
);


Fileset src_GetValue_Inspc = 
( ../../emc/source/Inspc/GetValue_Inspc.c
, ../../emc/source/InspcJ2c/SearchElement_Inspc.c
, ../../emc/source/emC/MemC_emC.c
, ../../emc/source/emC/SimpleC_emC.c
, ../../emc/source/emC/String_emC.c
, ../../emc/source/emC/StringBase_emC.c
, ../../emc/source/emC/StringBuilder_emC.c
, ../../emc/source/emC/Object_emC.c
, ../../emc/source/emC/Reflection_emC.c
, ../../emc/source/emC/ReflectionBaseTypes_emC.c
, ../../emc/source/emC/Formatter_emC.c
, ../../emc/source/emC/timeconversions_emC.c
, ../../emc/source/emC/handle_ptr64_emC.c
, ../../emc/source/emC/Memfree_ThreadAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/Exception_emC.c
, ../../emc/sourceApplSpecific/applConv/ExceptionPrintStacktrace_emC.c
, ../../emc/sourceApplSpecific/applConv/ApplSimpleStop_emC.c                 ##TODO force error message in SImulink
, ../../emc/sourceApplSpecific/applConv/ThreadContextMultiThreading_emC.c
##, ../../emc/sourceApplSpecific/applConv/PlatformConvSimpleStop.c 
, ../../emc/sourceApplSpecific/applConv/ObjectJc_allocStartup_emC.c
##, ../../emc/sourceSpecials/FwConv_c/free_ThreadHeapAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/UmlContainer_Dummy.c        
, ../../emc/sourceApplSpecific/applConv/RemoteCpu_Dummy.c
, ../../emc/source/Jc/ReflectionJc.c
, ../../emc/source/Jc/ReflectionBaseTypesJc.c
, ../../emc/source/Jc/ReflMemAccessJc.c
, ../../emc/source/Jc/ObjectJc.c
, ../../emc/source/Jc/AssertJc.c
, ../../emc/source/Jc/LocaleJc.c
, ../../emc/source/Jc/OsWrapperJc.c
, ../../emc/source/Jc/ThreadJc.c
, ../../emc/source/Jc/MathJc.c
, ../../emc/source/Jc/CharsetJc.c
, ../../emc/source/Jc/ArraysJc.c
, ../../emc/source/Jc/SystemJc.c
, ../../emc/source/Jc/SystemOutJc.c
, ../../emc/source/Jc/StringJc.c
, ../../emc/source/Jc/StringBufferJc.c
, ../../emc/source/Jc/StringValueConvJc.c
, ../../emc/source/Jc/PrintStreamJc.c
, ../../emc/source/J1c/StringFunctions_CJc.c
, ../../emc/source/refl/Reflection_OSAL.c
, ../../emc/source/OSAL/os_common.c
, ../../emc/sourceSpecials/os_Windows_64/os_atomic.c  
, ../../emc/sourceSpecials/osal_Windows/os_mem.c
, ../../emc/sourceSpecials/osal_Windows/os_time.c
, ../../emc/sourceSpecials/osal_Windows/os_mutex.c
, ../../emc/sourceSpecials/osal_Windows/os_thread.c
, ../../emc/sourceSpecials/osal_Windows/os_sharedmem.c
, ../../emc/sourceSpecials/osal_Windows_Msc15/os_file.c   
, ../../emc/sourceSpecials/osal_Windows/os_sync.c
, ../../emc/sourceApplSpecific/applConv/os_endian_x86.c
);





Fileset src_Service_Inspc = 
( ../../emc/source/Inspc/Service_Inspc.c
, ../../emc/source/Inspc/DataNode_Inspc.c
, ../../emc/source/InspcJ2c/AnswerComm_ifc_Inspc.c
, ../../emc/source/InspcJ2c/ClassContent_Inspc.c
, ../../emc/source/InspcJ2c/CmdConsumer_ifc_Inspc.c
, ../../emc/source/InspcJ2c/CmdExecuter_Inspc.c
, ../../emc/source/InspcJ2c/Comm_Inspc.c
, ../../emc/source/InspcJ2c/InspcDataExchangeAccess_Inspc.c
, ../../emc/source/InspcJ2c/InspcDataInfo_Inspc.c
, ../../emc/source/InspcJ2c/Inspector_Inspc.c
, ../../emc/source/InspcJ2c/SearchElement_Inspc.c
, ../../emc/source/Ipc/InterProcessCommSocket.c
, ../../emc/source/Ipc2c/InterProcessCommFactorySocket_Ipc.c
, ../../emc/source/Ipc/InterProcessComm.c
, ../../emc/source/J1c/ByteDataAccessBaseJc.c
, ../../emc/source/emC/MemC_emC.c
, ../../emc/source/emC/SimpleC_emC.c
, ../../emc/source/emC/String_emC.c
, ../../emc/source/emC/StringBase_emC.c
, ../../emc/source/emC/StringBuilder_emC.c
, ../../emc/source/emC/Object_emC.c
, ../../emc/source/emC/Time_emC.c
, ../../emc/source/emC/Reflection_emC.c
, ../../emc/source/emC/ReflectionBaseTypes_emC.c
, ../../emc/source/emC/Formatter_emC.c
, ../../emc/source/emC/timeconversions_emC.c
, ../../emc/source/emC/handle_ptr64_emC.c
, ../../emc/source/emC/Memfree_ThreadAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/Exception_emC.c
, ../../emc/sourceApplSpecific/applConv/ExceptionPrintStacktrace_emC.c
, ../../emc/sourceApplSpecific/applConv/ApplSimpleStop_emC.c                 ##TODO force error message in SImulink
, ../../emc/sourceApplSpecific/applConv/ThreadContextMultiThreading_emC.c
##, ../../emc/sourceApplSpecific/applConv/PlatformConvSimpleStop.c 
, ../../emc/sourceApplSpecific/applConv/ObjectJc_allocStartup_emC.c
##, ../../emc/sourceSpecials/FwConv_c/free_ThreadHeapAndBlockHeap.c
, ../../emc/sourceApplSpecific/applConv/UmlContainer_Dummy.c        
, ../../emc/sourceApplSpecific/applConv/RemoteCpu_Dummy.c
, ../../emc/source/Jc/ObjectJc.c
, ../../emc/source/Jc/AssertJc.c
, ../../emc/source/Jc/OsWrapperJc.c
, ../../emc/source/Jc/ThreadJc.c
, ../../emc/source/Jc/MathJc.c
, ../../emc/source/Jc/CharsetJc.c
, ../../emc/source/Jc/ArraysJc.c
, ../../emc/source/Jc/SystemJc.c
, ../../emc/source/Jc/SystemOutJc.c
, ../../emc/source/Jc/StringJc.c
, ../../emc/source/Jc/StringValueConvJc.c
, ../../emc/source/Jc/StringBufferJc.c
, ../../emc/source/Jc/PrintStreamJc.c
, ../../emc/source/J1c/StringFunctionsJc.c
, ../../emc/source/J1c/StringFunctions_CJc.c
, ../../emc/source/Jc/ReflectionJc.c
, ../../emc/source/Jc/ReflectionBaseTypesJc.c
, ../../emc/source/Jc/ReflMemAccessJc.c
, ../../emc/source/Jc/FileIoJc.c                          
, ../../emc/source/Jc/LocaleJc.c  
, ../../emc/source/refl/Reflection_OSAL.c
, ../../emc/source/OSAL/os_common.c
, ../../emc/sourceSpecials/os_Windows_64/os_atomic.c  
, ../../emc/sourceSpecials/osal_Windows/os_mem.c
, ../../emc/sourceSpecials/osal_Windows/os_time.c
, ../../emc/sourceSpecials/osal_Windows/os_mutex.c
, ../../emc/sourceSpecials/osal_Windows/os_thread.c
, ../../emc/sourceSpecials/osal_Windows/os_sharedmem.c
, ../../emc/sourceSpecials/osal_Windows_Msc15/os_file.c   
, ../../emc/sourceSpecials/osal_Windows/os_sync.c
, ../../emc/sourceSpecials/osal_Windows/os_socket.c
, ../../emc/sourceApplSpecific/applConv/os_endian_x86.c
);


Fileset XXXsrc_Service_Inspc = 
( gensrc_Refl/SimTime_Inspc_crefl.c

##, ../../emc/source/Inspc/Service_Inspc.c
, gensrc_Refl/Service_Inspc_crefl.c
);



Fileset lib_Service_Inspc = 
( lib/mex/ws2_32
##, mex/Inspc_SmlkAccl
 //, C:\Programs\Matlab\R2016a\sys\lcc64\lcc64\lib64\ws2_32
);                                                              




##Docu: if this Subtextvar is found, the memory for the Object Function Blocks is gotten in the function InitializeConditions.
##If the genAllocmem is not existing or null, The Sfunctions will get a second output for a bus which presents the internal data.
##Because the code generation provides a memory space with pointer, that is used.
##Note that some special condition 'don't reuse' etc. should be set for code generation optimizations.
##
Subtextvar genAllocmem(String dst, String nameStruct, Num ident) =
<:>(<&nameStruct>*) malloc(sizeof(<&nameStruct>))  /*JZtc: user-specific ExampleObjO*/ <.>;

main() { ##main routine for the JZtxtcmd:

  zmake "lib:lib_Inspc" := simulinkSfuncBusGen(&srcHeader, coptions="-TP -EHa" 
    , dirMexDbg = "../mexDbg", dirMex = "lib/mex"
    , dirMexcc=":+genSfn", dirSfunc = ":+genSfn/Inspc", dirTlc = ":+genSfn/Inspc"
    , dirRefl = null ##Reflections are part of the emC sources.
    ##, html=":test.html"  ##only for internally data view
    );

}

==endJZcmd==
%}
