@echo off
REM invoke from current dir, where this file is stored.
SET LOGDIR=stimuli_Selection_Log_deleteMe
if not exist %LOGDIR% mkdir %LOGDIR% 
REM invokes the stimuli selection GUI
REM Decision whether a 32.bit or 64.bit SWT library should be used depends on the java version 32 or 64, not on the Operation System.
::set SWTJAR=org.eclipse.swt.win32.win32.x86_3.5.1.v3555a.jar
set SWTJAR=org.eclipse.swt.win32.win32.x86_64_3.106.0.v20161027-0130.jar

REM if javaw is used, the console window remain open but can be closed manually independent of the java run.
REM The >out and >err can be used. If start is used here, >out and >err do not work. 
REM Then no information is given on faulty conditions, especially missing jars.
REM Therefore 'start' cannot be used here.
REM write out the command line to help explore the starting conditions on faulty situation:
@echo on  
javaw -cp ../../../../../Java/vishiajar/vishiaGui.jar;../../../../../Java/vishiajar/zbnf.jar;../../../../../Java/vishiajar/%SWTJAR% org.vishia.simSelector.SimSelector %0 1>%LOGDIR%\log.txt 2>%LOGDIR%\err.txt
@echo off
type %LOGDIR%\err.txt
::if errorlevel 1 pause
REM exit /b means, the console window remain open though this called batch will be finished. exit pure closes the console.
exit /b 

==JZtxtcmd==

include stimuli_template.m.jzT.cmd;    ##the template for the simulink stimuli file
include setInspcArgs_template.jzTc;
include "../../../lib/stimuli/createStimuli.jzTc";

currdir = <:><&scriptdir><.>;


String dirSimulink = "..";  ##the directory for this model in simulink
Filepath outputCsvStimuli = "+genstimuli/testStimuli.m.csv";
String fileStimuli_inspc  = "+genstimuli/genStimuli_inspc.jz.cmd";
String fileStimuli_m      = "+genstimuli/genStimuli.m";
String fileTestCases_m    = "+genstimuli/genTestCases.m";

List vars =
[ Subtextvar name = <:><&var1.name>_<&var2.name>_<&var3.name>_<&var4.name>_<&var5.name>_<.>;
  Subtextvar Description = <:><&var1.descr> <&var2.descr> <&var3.descr> <&var4.descr> <&var5.descr><.>;
  Subtextvar Identifier =  <:><&var1.name>_<&var2.name>_<&var3.name>_<&var4.name>_<&var5.name><.>; 
  String     activate = "1";
  Subtextvar t1 = <:><&var1.t1><.>;
  Subtextvar t2 = <:><&var1.t2><.>;
  Subtextvar t3 = <:><&var1.t3><.>;
  Subtextvar val1 = <:><&var2.val1><.>;
  Subtextvar val2 = <:><&var2.val2><.>;
  Subtextvar val3 = <:><&var2.val3><.>;
  Subtextvar spline = <:><&var3.spline><.>;
  Subtextvar nref = <:><&var1.nref><.>;
  Subtextvar Mref = <:><&var2.Mref><.>;
];                                                                                          

##Character for test case selection:
## M All moment force
## n All rotation speeds

List variation_1 =  ##times
[ { name="slow",  select="x",   t1="3.0", t2="5.0", t3="8.0", descr="slow cycle"    } 
, { name="slow2",  select="x",  t1="2.0", t2="5.0", t3="6.0", descr="middle cycle"    }
, { name="mid1",  select="x",   t1="2.0", t2="4.0", t3="6.0", descr="middle cycle"    }
, { name="mid2",  select="x",   t1="2.0", t2="3.0", t3="4.0", descr="faster cycle"    }
, { name="fast",  select="GJ",   t1="1.0", t2="1.7", t3="2.5", descr="fast cycle"    }
];

List variation_2 =  ##levels
[ { name="low1",   select="x", val1="=>1.0", val2="=>1.5", val3="=>0.5", descr="/ 1.5 \ "    } 
, { name="low2",   select="x", val1="=>1.0", val2="=>2.5", val3="=>0.5", descr="/ 2.5 \ "    }
, { name="jlow2",  select="x", val1="=>1.0", val2="=2.5",  val3="=0.5",  descr="- 2.5 - "    }
, { name="mid1",   select="G", val1="=>1.0", val2="=>3.5", val3="=>0.5", descr="/ 3.5 \ "    }
, { name="jmid1",  select="J", val1="=>1.0", val2="=3.5",  val3="=0.5",  descr="- 3.5 - "    }
, { name="midup",  select="A", val1="=>1.0", val2="=>4.5", val3="=>8.0", descr="/ 4.5 / 8 "    }
, { name="high1",  select="G", val1="=>1.0", val2="=>8.0", val3="=>0.0", descr="/ 8.0 \ "    }
, { name="jhigh1", select="x", val1="=>1.0", val2="=8.0",  val3="= 0.0", descr="- 8.0 - "    }
, { name="high2",  select="G", val1="=>8.0", val2="=>0.5", val3="=>8.0", descr="8 \ 0.5 / 8 "    }
, { name="jhigh2", select="x", val1="=>8.0", val2="=0.5",  val3="=8.0",  descr="8 - 0.5 - 8 "    }
];
                                                            
                                                                   
List variation_3 = ##spline
[ { name="ramp",           select="GJ", spline="",      ramp=">",  descr="ramp"    } 
, { name="fastSpline",     select="x", spline="-0.05", ramp=">",  descr="0.05"    }
, { name="midSpline",      select="x", spline="-0.1",  ramp=">",  descr="0,1"    }
, { name="slowSpline",     select="G", spline="-0.3",  ramp=">",  descr="spline=0.3"    }
, { name="verySlowSpline", select="A", spline="-1.0",  ramp=">",  descr="spline=1.0"    }
];

                                

List variation_4 =                                            
[ { name = "-",   select="GJZOKRIPABWETWLMH",descr="not used", Filter_switch_c1="0"  }
, { name = "Filter_1",   select="B",descr="filter 1", Filter_switch_c1="1" }
, { name = "Filter_0",   select="B",descr="filter 0", Filter_switch_c1="0" }
];
                                                                
                               
List variation_5 =   ##unused         
[ { name="x",  select="GJ",     nref="1100", Mref = "3.1", descr="dummy"    } 
];


